diff --git a/sql/datadict.cc b/sql/datadict.cc
index 62d60ed..2f01bf2 100644
--- a/sql/datadict.cc
+++ b/sql/datadict.cc
@@ -169,7 +169,7 @@ bool dd_recreate_table(THD *thd, const char *db, const char *table_name,
   }
 
   /* Attempt to reconstruct the table. */
-  error= ha_create_table(thd, path, db, table_name, &create_info, NULL);
+  error= ha_create_table(thd, path, db, table_name, &create_info, NULL, 0);
 
   DBUG_RETURN(error);
 }
diff --git a/sql/handler.cc b/sql/handler.cc
index 1f8daf3..a44e3b1 100644
--- a/sql/handler.cc
+++ b/sql/handler.cc
@@ -4630,7 +4630,8 @@ void handler::update_global_index_stats()
 */
 int ha_create_table(THD *thd, const char *path,
                     const char *db, const char *table_name,
-                    HA_CREATE_INFO *create_info, LEX_CUSTRING *frm)
+                    HA_CREATE_INFO *create_info, LEX_CUSTRING *frm,
+                    ulong privilege)
 {
   int error= 1;
   TABLE table;
@@ -4667,7 +4668,8 @@ int ha_create_table(THD *thd, const char *path,
 
   share.m_psi= PSI_CALL_get_table_share(temp_table, &share);
 
-  if (open_table_from_share(thd, &share, "", 0, READ_ALL, 0, &table, true))
+  if (open_table_from_share(thd, &share, "", 0, READ_ALL, 0,
+                            &table, true, privilege))
     goto err;
 
   update_create_info_from_table(create_info, &table);
diff --git a/sql/handler.h b/sql/handler.h
index 2e219d5..e488f79 100644
--- a/sql/handler.h
+++ b/sql/handler.h
@@ -4043,7 +4043,8 @@ void ha_checkpoint_state(bool disable);
 void ha_commit_checkpoint_request(void *cookie, void (*pre_hook)(void *));
 int ha_create_table(THD *thd, const char *path,
                     const char *db, const char *table_name,
-                    HA_CREATE_INFO *create_info, LEX_CUSTRING *frm);
+                    HA_CREATE_INFO *create_info, LEX_CUSTRING *frm,
+                    ulong privilege);
 int ha_delete_table(THD *thd, handlerton *db_type, const char *path,
                     const char *db, const char *alias, bool generate_warning);
 
diff --git a/sql/sql_admin.cc b/sql/sql_admin.cc
index a6b97ce..f761db4 100644
--- a/sql/sql_admin.cc
+++ b/sql/sql_admin.cc
@@ -135,7 +135,7 @@ static int prepare_for_repair(THD *thd, TABLE_LIST *table_list,
     if (share == NULL)
       DBUG_RETURN(0);				// Can't open frm file
 
-    if (open_table_from_share(thd, share, "", 0, 0, 0, &tmp_table, FALSE))
+    if (open_table_from_share(thd, share, "", 0, 0, 0, &tmp_table, FALSE, 0))
     {
       tdc_release_share(share);
       DBUG_RETURN(0);                           // Out of memory
diff --git a/sql/sql_base.cc b/sql/sql_base.cc
index 13b8625..68aed5c 100644
--- a/sql/sql_base.cc
+++ b/sql/sql_base.cc
@@ -2511,7 +2511,7 @@ bool open_table(THD *thd, TABLE_LIST *table_list, MEM_ROOT *mem_root,
                                          HA_TRY_READ_ONLY),
                                  (READ_KEYINFO | COMPUTE_TYPES |
                                   EXTRA_RECORD),
-                                 thd->open_options, table, FALSE);
+                                 thd->open_options, table, FALSE, 0);
 
     if (error)
     {
@@ -3346,7 +3346,7 @@ static bool auto_repair_table(THD *thd, TABLE_LIST *table_list)
                                     HA_TRY_READ_ONLY),
                             READ_KEYINFO | COMPUTE_TYPES | EXTRA_RECORD,
                             ha_open_options | HA_OPEN_FOR_REPAIR,
-                            entry, FALSE) || ! entry->file ||
+                            entry, FALSE, 0) || ! entry->file ||
       (entry->file->is_crashed() && entry->file->ha_check_and_repair(thd)))
   {
     /* Give right error message */
@@ -5621,7 +5621,8 @@ TABLE *open_table_uncached(THD *thd, handlerton *hton,
                            const char *path, const char *db,
                            const char *table_name,
                            bool add_to_temporary_tables_list,
-                           bool open_in_engine)
+                           bool open_in_engine,
+                           ulong privilege)
 {
   TABLE *tmp_table;
   TABLE_SHARE *share;
@@ -5681,7 +5682,7 @@ TABLE *open_table_uncached(THD *thd, handlerton *hton,
                               Set "is_create_table" if the table does not
                               exist in SE
                             */
-                            open_in_engine ? false : true))
+                            open_in_engine ? false : true, privilege))
   {
     /* No need to lock share->mutex as this is not needed for tmp tables */
     free_table_share(share);
@@ -5690,7 +5691,7 @@ TABLE *open_table_uncached(THD *thd, handlerton *hton,
   }
 
   tmp_table->reginfo.lock_type= TL_WRITE;	 // Simulate locked
-  tmp_table->grant.privilege= TMP_TABLE_ACLS;
+  tmp_table->grant.privilege= privilege;
   share->tmp_table= (tmp_table->file->has_transactions() ? 
                      TRANSACTIONAL_TMP_TABLE : NON_TRANSACTIONAL_TMP_TABLE);
 
diff --git a/sql/sql_base.h b/sql/sql_base.h
index a6d9019..d9b1a1f 100644
--- a/sql/sql_base.h
+++ b/sql/sql_base.h
@@ -130,7 +130,7 @@ bool get_key_map_from_key_list(key_map *map, TABLE *table,
 TABLE *open_table_uncached(THD *thd, handlerton *hton, const char *path,
                            const char *db, const char *table_name,
                            bool add_to_temporary_tables_list,
-                           bool open_in_engine);
+                           bool open_in_engine, ulong privilege);
 TABLE *find_locked_table(TABLE *list, const char *db, const char *table_name);
 TABLE *find_write_locked_table(TABLE *list, const char *db,
                                const char *table_name);
diff --git a/sql/sql_insert.cc b/sql/sql_insert.cc
index 1ec33a0..d0cb0f7 100644
--- a/sql/sql_insert.cc
+++ b/sql/sql_insert.cc
@@ -3952,6 +3952,7 @@ static TABLE *create_table_from_items(THD *thd, HA_CREATE_INFO *create_info,
       }
       /* Restore */
       create_table->open_strategy= save_open_strategy;
+      create_table->table->grant.privilege= create_table->grant.privilege;
     }
     else
     {
diff --git a/sql/sql_parse.cc b/sql/sql_parse.cc
index 5635e9a..55cc4be 100644
--- a/sql/sql_parse.cc
+++ b/sql/sql_parse.cc
@@ -6936,6 +6936,17 @@ TABLE_LIST *st_select_lex::add_table_to_list(THD *thd,
 #ifdef WITH_PARTITION_STORAGE_ENGINE
   ptr->partition_names= partition_names;
 #endif /* WITH_PARTITION_STORAGE_ENGINE */
+#ifdef NO_EMBEDDED_ACCESS_CHECKS
+  /*
+    Plugins (e.g. CONNECT engine) should not depend on whether
+    embedded library is built with or without NO_EMBEDDED_ACCESS_CHECKS.
+    ha_xxx::external_lock() expects that tables->grant.privilege
+    is initialized to allow all privileges if NO_EMBEDDED_ACCESS_CHECKS.
+    E.g. ha_connect::external_lock() needs FILE_ACL.
+  */
+  ptr->grant.privilege= ~NO_ACCESS;
+#endif
+
   /* Link table in global list (all used tables) */
   lex->add_to_query_tables(ptr);
 
diff --git a/sql/sql_show.cc b/sql/sql_show.cc
index 2413cb5..fd2c118 100644
--- a/sql/sql_show.cc
+++ b/sql/sql_show.cc
@@ -4634,7 +4634,7 @@ static int fill_schema_table_from_frm(THD *thd, TABLE_LIST *tables,
 
   if (!open_table_from_share(thd, share, table_name->str, 0,
                              (EXTRA_RECORD | OPEN_FRM_FILE_ONLY),
-                             thd->open_options, &tbl, FALSE))
+                             thd->open_options, &tbl, FALSE, 0))
   {
     tbl.s= share;
     table_list.table= &tbl;
diff --git a/sql/sql_table.cc b/sql/sql_table.cc
index 20cfcca..bf1e4fb 100644
--- a/sql/sql_table.cc
+++ b/sql/sql_table.cc
@@ -4837,7 +4837,8 @@ int create_table_impl(THD *thd,
     */
 
     TABLE *table= open_table_uncached(thd, create_info->db_type, path,
-                                      db, table_name, true, true);
+                                      db, table_name, true, true,
+                                      TMP_TABLE_ACLS);
 
     if (!table)
     {
@@ -4871,7 +4872,7 @@ int create_table_impl(THD *thd,
 
     bool result= (open_table_def(thd, &share, GTS_TABLE) ||
                   open_table_from_share(thd, &share, "", 0, (uint) READ_ALL,
-                                        0, &table, true));
+                                        0, &table, true, 0));
     if (!result)
       (void) closefrm(&table, 0);
 
@@ -8720,7 +8721,15 @@ bool mysql_alter_table(THD *thd,char *new_db, char *new_name,
                                              alter_ctx.get_tmp_path(),
                                              alter_ctx.new_db,
                                              alter_ctx.tmp_name,
-                                             true, false)))
+                                             true, false,
+                                             /*
+                                               Some engine, e.g. CONNECT,
+                                               need to know if FILE_ACL
+                                               presents.
+                                             */
+                                             TMP_TABLE_ACLS |
+                                             (table_list->grant.privilege &
+                                             FILE_ACL))))
       goto err_new_table_cleanup;
 
     /* Set markers for fields in TABLE object for altered table. */
@@ -8865,7 +8874,7 @@ bool mysql_alter_table(THD *thd,char *new_db, char *new_name,
 
   if (ha_create_table(thd, alter_ctx.get_tmp_path(),
                       alter_ctx.new_db, alter_ctx.tmp_name,
-                      create_info, &frm))
+                      create_info, &frm, table_list->grant.privilege))
     goto err_new_table_cleanup;
 
   /* Mark that we have created table in storage engine. */
@@ -8876,7 +8885,7 @@ bool mysql_alter_table(THD *thd,char *new_db, char *new_name,
     if (!open_table_uncached(thd, new_db_type,
                              alter_ctx.get_tmp_path(),
                              alter_ctx.new_db, alter_ctx.tmp_name,
-                             true, true))
+                             true, true, TMP_TABLE_ACLS))
       goto err_new_table_cleanup;
   }
 
@@ -8897,7 +8906,7 @@ bool mysql_alter_table(THD *thd,char *new_db, char *new_name,
     /* Open our intermediate table. */
     new_table= open_table_uncached(thd, new_db_type, alter_ctx.get_tmp_path(),
                                    alter_ctx.new_db, alter_ctx.tmp_name,
-                                   true, true);
+                                   true, true, table_list->grant.privilege);
   }
   if (!new_table)
     goto err_new_table_cleanup;
@@ -9111,7 +9120,7 @@ bool mysql_alter_table(THD *thd,char *new_db, char *new_name,
     TABLE *t_table;
     t_table= open_table_uncached(thd, new_db_type, alter_ctx.get_new_path(),
                                  alter_ctx.new_db, alter_ctx.new_name,
-                                 false, true);
+                                 false, true, TMP_TABLE_ACLS);
     if (t_table)
       intern_close_table(t_table);
     else
diff --git a/sql/sql_truncate.cc b/sql/sql_truncate.cc
index 05869b7..92acf32 100644
--- a/sql/sql_truncate.cc
+++ b/sql/sql_truncate.cc
@@ -297,7 +297,8 @@ static bool recreate_temporary_table(THD *thd, TABLE *table)
 
   if ((new_table= open_table_uncached(thd, table_type, share->path.str,
                                       share->db.str,
-                                      share->table_name.str, true, true)))
+                                      share->table_name.str, true, true,
+                                      TMP_TABLE_ACLS)))
   {
     error= FALSE;
     thd->thread_specific_used= TRUE;
diff --git a/sql/table.cc b/sql/table.cc
index 053269a..4cd4fa3 100644
--- a/sql/table.cc
+++ b/sql/table.cc
@@ -2543,7 +2543,8 @@ bool unpack_vcol_info_from_frm(THD *thd,
 enum open_frm_error open_table_from_share(THD *thd, TABLE_SHARE *share,
                        const char *alias, uint db_stat, uint prgflag,
                        uint ha_open_flags, TABLE *outparam,
-                       bool is_create_table)
+                       bool is_create_table,
+                       ulong privilege)
 {
   enum open_frm_error error;
   uint records, i, bitmap_size;
@@ -2559,6 +2560,7 @@ enum open_frm_error open_table_from_share(THD *thd, TABLE_SHARE *share,
 
   error= OPEN_FRM_ERROR_ALREADY_ISSUED; // for OOM errors below
   bzero((char*) outparam, sizeof(*outparam));
+  outparam->grant.privilege= privilege;
   outparam->in_use= thd;
   outparam->s= share;
   outparam->db_stat= db_stat;
diff --git a/sql/table.h b/sql/table.h
index 39faa8b..6a668b0 100644
--- a/sql/table.h
+++ b/sql/table.h
@@ -2557,7 +2557,7 @@ void init_mdl_requests(TABLE_LIST *table_list);
 enum open_frm_error open_table_from_share(THD *thd, TABLE_SHARE *share,
                        const char *alias, uint db_stat, uint prgflag,
                        uint ha_open_flags, TABLE *outparam,
-                       bool is_create_table);
+                       bool is_create_table, ulong privilege);
 bool unpack_vcol_info_from_frm(THD *thd, MEM_ROOT *mem_root,
                                TABLE *table, Field *field,
                                LEX_STRING *vcol_expr, bool *error_reported);
diff --git a/sql/unireg.cc b/sql/unireg.cc
index 12d3c26..e8fa92e 100644
--- a/sql/unireg.cc
+++ b/sql/unireg.cc
@@ -375,7 +375,7 @@ int rea_create_table(THD *thd, LEX_CUSTRING *frm,
 
   if (!no_ha_create_table)
   {
-    if (ha_create_table(thd, path, db, table_name, create_info, frm))
+    if (ha_create_table(thd, path, db, table_name, create_info, frm, 0))
       goto err_part;
   }
 
diff --git a/storage/connect/ha_connect.cc b/storage/connect/ha_connect.cc
index c2fb648..51e7102 100644
--- a/storage/connect/ha_connect.cc
+++ b/storage/connect/ha_connect.cc
@@ -955,7 +955,7 @@ ulonglong ha_connect::table_flags() const
       flags|= (HA_HAS_RECORDS | HA_STATS_RECORDS_IS_EXACT);
 
     // No data change on ALTER for outward tables
-    if (!IsFileType(type) || hp->FileExists(pos->filename, true))
+    if (!IsFileType(type) || hp->FileExists(pos->filename, true, true))
       flags|= HA_NO_COPY_ON_ALTER;
 
     } // endif pos
@@ -3964,7 +3964,21 @@ int ha_connect::delete_all_rows()
 } // end of delete_all_rows
 
 
-bool ha_connect::check_privileges(THD *thd, PTOS options, char *dbn)
+/**
+  Check privileges.
+  @param THD                   - Current thread
+  @param options               - Connect table options
+  @param dbn                   - database name
+  @param using_table_privilege - whether check table->grant.privilege,
+                                 or execute check_access(FILE_ACL).
+
+  Using table->grant.privilege is important in cases when we need to take into
+  account privileges of the VIEW definer when accessing to a view created with
+    "CREATE VIEW v1 SQL SECURITY DEFINER".
+  See ha_connect::check_privileges_external_lock() for details.
+*/
+bool ha_connect::check_privileges(THD *thd, PTOS options, char *dbn,
+                                  bool using_table_privilege)
 {
   const char *db= (dbn && *dbn) ? dbn : NULL;
   TABTYPE     type=GetRealType(options);
@@ -4020,7 +4034,33 @@ bool ha_connect::check_privileges(THD *thd, PTOS options, char *dbn)
     case TAB_MAC:
     case TAB_WMI:
     case TAB_OEM:
-      return check_access(thd, FILE_ACL, db, NULL, NULL, 0, 0);
+      if (using_table_privilege)
+      {
+        // Called from ::external_lock(), respect VIEW's definer
+        if (table->grant.privilege & FILE_ACL)
+          return false;
+        else
+        {
+          my_error(ER_ACCESS_DENIED_ERROR, MYF(0),
+                   thd->security_ctx->priv_user,
+                   thd->security_ctx->priv_host,
+                   (thd->password ?  ER(ER_YES) : ER(ER_NO)));
+          return true;
+        }
+      }
+      else
+      {
+        /*
+          Called from ::create() or ::delete_or_rename_table().
+          TODO:
+          - change create() to use table->grant.privilege as well
+            (needs some additional refactoring in /sql)
+          - change delete_or_rename_table() not to require FILE_ACL,
+            This should be safe, as DROP and RENAME queries do not
+            actually read or modify the underlying data file.
+        */
+        return check_access(thd, FILE_ACL, db, NULL, NULL, 0, 0);
+      }
 
     // This is temporary until a solution is found
     case TAB_TBL:
@@ -4061,6 +4101,15 @@ bool ha_connect::IsSameIndex(PIXDEF xp1, PIXDEF xp2)
   return b;
 } // end of IsSameIndex
 
+
+void ha_connect::report_unsupported_sql_command(PGLOBAL g, THD *thd)
+{
+  htrc("Unsupported sql_command=%d\n", thd_sql_command(thd));
+  strcpy(g->Message, "CONNECT Unsupported command");
+  my_message(ER_NOT_ALLOWED_COMMAND, g->Message, MYF(0));
+}
+
+
 MODE ha_connect::CheckMode(PGLOBAL g, THD *thd,
                            MODE newmode, bool *chk, bool *cras)
 {
@@ -4121,9 +4170,7 @@ MODE ha_connect::CheckMode(PGLOBAL g, THD *thd,
 //        } // endif partitioned
 
       default:
-        htrc("Unsupported sql_command=%d\n", thd_sql_command(thd));
-        strcpy(g->Message, "CONNECT Unsupported command");
-        my_message(ER_NOT_ALLOWED_COMMAND, g->Message, MYF(0));
+        report_unsupported_sql_command(g, thd);
         newmode= MODE_ERROR;
         break;
       } // endswitch newmode
@@ -4175,9 +4222,7 @@ MODE ha_connect::CheckMode(PGLOBAL g, THD *thd,
         newmode= MODE_READ;
         break;
       default:
-        htrc("Unsupported sql_command=%d\n", thd_sql_command(thd));
-        strcpy(g->Message, "CONNECT Unsupported command");
-        my_message(ER_NOT_ALLOWED_COMMAND, g->Message, MYF(0));
+        report_unsupported_sql_command(g, thd);
         newmode= MODE_ERROR;
         break;
       } // endswitch newmode
@@ -4190,6 +4235,43 @@ MODE ha_connect::CheckMode(PGLOBAL g, THD *thd,
   return newmode;
 } // end of check_mode
 
+
+/**
+  A check_privileges() wrapper for external_lock().
+*/
+bool ha_connect::check_privileges_external_lock(PGLOBAL g, THD *thd,
+                                                PTOS options)
+{
+  switch (thd_sql_command(thd))
+  {
+  case SQLCOM_SELECT:
+  case SQLCOM_UPDATE:
+  case SQLCOM_INSERT:
+  case SQLCOM_DELETE:
+  case SQLCOM_REPLACE:
+  case SQLCOM_LOAD:
+  case SQLCOM_CREATE_TABLE:
+  case SQLCOM_INSERT_SELECT:
+  case SQLCOM_REPLACE_SELECT:
+  case SQLCOM_UPDATE_MULTI:
+  case SQLCOM_DELETE_MULTI:
+  case SQLCOM_TRUNCATE:
+  case SQLCOM_LOCK_TABLES:
+  case SQLCOM_DROP_TABLE:
+  case SQLCOM_RENAME_TABLE:
+  case SQLCOM_CREATE_VIEW:
+  case SQLCOM_DROP_INDEX:
+  case SQLCOM_CREATE_INDEX:
+  case SQLCOM_OPTIMIZE:
+  case SQLCOM_ALTER_TABLE:
+    return check_privileges(thd, options, table->s->db.str, true);
+  default:
+    report_unsupported_sql_command(g, thd);
+  }
+  return true;                       // Something went wrong, deny access.
+}
+
+
 int ha_connect::start_stmt(THD *thd, thr_lock_type lock_type)
 {
   int     rc= 0;
@@ -4410,7 +4492,7 @@ int ha_connect::external_lock(THD *thd, int lock_type)
 
   DBUG_ASSERT(table && table->s);
 
-  if (check_privileges(thd, options, table->s->db.str)) {
+  if (check_privileges_external_lock(g, thd, options)) {
     strcpy(g->Message, "This operation requires the FILE privilege");
     htrc("%s\n", g->Message);
     DBUG_RETURN(HA_ERR_INTERNAL_ERROR);
@@ -4661,7 +4743,7 @@ int ha_connect::delete_or_rename_table(const char *name, const char *to)
     if (!open_table_def(thd, share)) {
       // Now we can work
       if ((pos= share->option_struct)) {
-        if (check_privileges(thd, pos, db))
+        if (check_privileges(thd, pos, db, false))
           rc= HA_ERR_INTERNAL_ERROR;         // ???
         else
           if (IsFileType(GetRealType(pos)) && !pos->filename)
@@ -5670,6 +5752,14 @@ int ha_connect::create(const char *name, TABLE *table_arg,
   PGLOBAL g= xp->g;
 
   DBUG_ENTER("ha_connect::create");
+  /*
+    This assignment fixes sporadic test failures if some
+    "ALTER TABLE t1 ADD KEY(a)" query exits on ER_ACCESS_DENIED_ERROR
+    (e.g. on missing FILE_ACL). All following "CREATE TABLE" failed with
+    "ERROR 1105: CONNECT index modification should be in-place"
+    TODO: check with Olivier.
+  */
+  g->Xchk= NULL;
   int  sqlcom= thd_sql_command(table_arg->in_use);
   PTOS options= GetTableOptionStruct(table_arg->s);
 
@@ -5699,7 +5789,7 @@ int ha_connect::create(const char *name, TABLE *table_arg,
     DBUG_RETURN(HA_ERR_INTERNAL_ERROR);
   } // endif ttp
 
-  if (check_privileges(thd, options, GetDBfromName(name)))
+  if (check_privileges(thd, options, GetDBfromName(name), false))
     DBUG_RETURN(HA_ERR_INTERNAL_ERROR);
 
   inward= IsFileType(type) && !options->filename;
@@ -6066,7 +6156,7 @@ int ha_connect::create(const char *name, TABLE *table_arg,
 #endif   // WITH_PARTITION_STORAGE_ENGINE
 
     if (g->Alchecked == 0 &&
-        (!IsFileType(type) || FileExists(options->filename, false))) {
+        (!IsFileType(type) || FileExists(options->filename, false, true))) {
       if (part_info) {
         sprintf(g->Message, "Data repartition in %s is unchecked", partname); 
         push_warning(thd, Sql_condition::WARN_LEVEL_WARN, 0, g->Message);
@@ -6146,7 +6236,7 @@ int ha_connect::create(const char *name, TABLE *table_arg,
   - file does not exist or is void
   - user has file privilege
 */
-bool ha_connect::FileExists(const char *fn, bool bf)
+bool ha_connect::FileExists(const char *fn, bool bf, bool check_privilege)
 {
   if (!fn || !*fn)
     return false;
@@ -6159,8 +6249,7 @@ bool ha_connect::FileExists(const char *fn, bool bf)
     int   n;
     struct stat info;
 
-    if (check_access(ha_thd(), FILE_ACL, table->s->db.str,
-                     NULL, NULL, 0, 0))
+    if (check_privilege && !(table->grant.privilege & FILE_ACL))
       return true;
 
 #if defined(__WIN__)
@@ -6426,7 +6515,7 @@ ha_connect::check_if_supported_inplace_alter(TABLE *altered_table,
       char *fn= GetStringOption("filename");
       tshp= NULL;
 
-      if (FileExists(fn, false)) {
+      if (FileExists(fn, false, false)) {
         strcpy(g->Message, "Operation denied. Table data would be lost.");
         my_message(ER_UNKNOWN_ERROR, g->Message, MYF(0));
         DBUG_RETURN(HA_ALTER_ERROR);
diff --git a/storage/connect/ha_connect.h b/storage/connect/ha_connect.h
index 611f9ba..89af0df 100644
--- a/storage/connect/ha_connect.h
+++ b/storage/connect/ha_connect.h
@@ -213,7 +213,7 @@ class ha_connect: public handler
   bool     SetIntegerOption(char *opname, int n);
   bool     SameInt(TABLE *tab, char *opn);
   bool     SameBool(TABLE *tab, char *opn);
-  bool     FileExists(const char *fn, bool bf);
+  bool     FileExists(const char *fn, bool bf, bool check_privilege);
   bool     NoFieldOptionChange(TABLE *tab);
   PFOS     GetFieldOptionStruct(Field *fp);
   void    *GetColumnOption(PGLOBAL g, void *field, PCOLINFO pcf);
@@ -534,8 +534,11 @@ int index_prev(uchar *buf);
 private:
   DsMrr_impl ds_mrr;
 
+  void report_unsupported_sql_command(PGLOBAL g, THD *thd);
 protected:
-  bool check_privileges(THD *thd, PTOS options, char *dbn);
+  bool check_privileges(THD *thd, PTOS options, char *dbn,
+                        bool using_table_privilege);
+  bool check_privileges_external_lock(PGLOBAL g, THD *thd, PTOS options);
   MODE CheckMode(PGLOBAL g, THD *thd, MODE newmode, bool *chk, bool *cras);
   char *GetDBfromName(const char *name);
 
diff --git a/storage/connect/mysql-test/connect/r/grant.result b/storage/connect/mysql-test/connect/r/grant.result
index ba57287..9a0a549 100644
--- a/storage/connect/mysql-test/connect/r/grant.result
+++ b/storage/connect/mysql-test/connect/r/grant.result
@@ -46,7 +46,7 @@ ERROR 28000: Access denied for user 'user'@'localhost' (using password: NO)
 SELECT user();
 user()
 root@localhost
-CREATE VIEW v1 AS SELECT * FROM t1;
+CREATE SQL SECURITY INVOKER VIEW v1 AS SELECT * FROM t1;
 SELECT user();
 user()
 user@localhost
@@ -130,7 +130,7 @@ ERROR 28000: Access denied for user 'user'@'localhost' (using password: NO)
 SELECT user();
 user()
 root@localhost
-CREATE VIEW v1 AS SELECT * FROM t1;
+CREATE SQL SECURITY INVOKER VIEW v1 AS SELECT * FROM t1;
 SELECT user();
 user()
 user@localhost
@@ -224,7 +224,7 @@ ERROR 28000: Access denied for user 'user'@'localhost' (using password: NO)
 SELECT user();
 user()
 root@localhost
-CREATE VIEW v1 AS SELECT * FROM t1;
+CREATE SQL SECURITY INVOKER VIEW v1 AS SELECT * FROM t1;
 SELECT user();
 user()
 user@localhost
@@ -318,7 +318,7 @@ ERROR 28000: Access denied for user 'user'@'localhost' (using password: NO)
 SELECT user();
 user()
 root@localhost
-CREATE VIEW v1 AS SELECT * FROM t1;
+CREATE SQL SECURITY INVOKER VIEW v1 AS SELECT * FROM t1;
 SELECT user();
 user()
 user@localhost
@@ -412,7 +412,7 @@ ERROR 28000: Access denied for user 'user'@'localhost' (using password: NO)
 SELECT user();
 user()
 root@localhost
-CREATE VIEW v1 AS SELECT * FROM t1;
+CREATE SQL SECURITY INVOKER VIEW v1 AS SELECT * FROM t1;
 SELECT user();
 user()
 user@localhost
@@ -506,7 +506,7 @@ ERROR 28000: Access denied for user 'user'@'localhost' (using password: NO)
 SELECT user();
 user()
 root@localhost
-CREATE VIEW v1 AS SELECT * FROM t1;
+CREATE SQL SECURITY INVOKER VIEW v1 AS SELECT * FROM t1;
 SELECT user();
 user()
 user@localhost
